EDIT - bug #10138

Details view is not updated after freetext change
09/07/2022 10:12 AM - Katja Luther

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.35

Severity: critical Found in Version:

Description

... which may lead to data loss.
WGB:

FI. Cuba; ich habe eben 2 Synonyme eingegeben, und zwar folgendermafR3en:
Antidesma rosaurianum (‘rosariana’) M. Gémez

Antidesma rosariana M. Gomez

gepasted und Save

Die beiden standen normal in der Synonymliste, kein * im Tag, Save-Button nicht aktiv.

Dann wollte ich die 2. als original spelling auswahlen und fand sie nicht in der Liste.
Nach einigem Hin und Her dann das Taxon neu aufgerufen: Die Synonyme waren weg.

Ich versuche das jetzt nochmal.

ich habe das nochmal genau so gemacht:

b ™

(25 Astrocasiat..  |[BY Breyniadist.. | [&4 Chascotheca..  |[& Chascotheca.. | *Hieronymac.. %2 | ™ = B
® Hieronyma clusioides (Tul.) Griseb.
© sStlaginella clusicides Tul.
@ Hieronyma pallida Miill. Arg.
© Anfidesma cubanum var. pallidum (Miill. Arg.) M. Gomez [as "cubana var. pallida]
aAntidesma rosaurianum (‘Tosariana’) M. Gomez

& Antidesma rosariana M. Gomez

Falscher Eintrag (mit original spelling) —im Taxon Editor das (,rosariana‘) geléscht. Und gespeichert.
[:7L Search -

[,4:'; Taxen Mavigator &2 = <‘:==';> = O Léac Astrocasia t.. [,13'; Breynia dist... [,4:& Chascotheca ...
ﬂ:}?{";::gi{unth ~ ® Hieronyma clusioides (Tul.) Griseb.
Mellastnmataceae © Siilaginella clusicides Tul.
ﬁ:::::reri:z;e @ Hieronyma pallida Miill. Arg.

Menyanthaceae

© Antidesma cubanum var. pallidum (Miill. 2

Microteaceae
Melluginaceae
Montiaceae
Moraceae @ Antidesma rosariana M. Gomez
Meoringaceae Martinov

Muntingiaceae C. Bayer, M. W, Chase & M. F. Fay

@ Antidesmarosaurianum M. Gomez

Dann die Referenz eingetragen (ich weil3 nicht, ob letztes mal der Cache im Details View noch den alten Eintrag zeigte. Und auch
gleich das original spelling versucht einzutragen — war jetzt in der Namensliste vorhanden.

» Hieronyma clusicides (Tul.) Griseb. Appended PhrasEL J
© stilaginella clusioides Tul. + Authorship:
@ Hieronyma pallida Mill. Arg. Authorship Cache ‘ 3
© Antidesma cubanum var. pallidum (Miill. Arg.) M. Gémez [as "cubana var. pallida™] Author ‘
@ Antidesma rosaurianum M. Gomez Ex Author = o
@ Antidesmarosariana M. Gomez Basionym Author = a
Ex Basionym Author = o
~ Nomenclatural Source
Referer _ . PR ]
Details [ -
DRGEEISEERgE Antiaesma rosanana M. bomez zlalm

» Egmlmnuee’Orimq |
Appended Phrase | |

~ Authorship:

Authorship Cache  [REEERES
Author

L} Ex Author
Basionym Author

Name Facts &2 FZEE=0O Media 2 = 0
= & Ex Basionym Author

(L
C1EIEIE] e

b Hybrid

~ Momenclatural Source

Reference M. Gomez, Dice. Bot. Mombres Vulg. Cub. Puerto-Riq. 1889 =8 m
Details ‘
DRGSR Antidesma rosariana M. Gomez =

ABER: Trotz Save wird der Name nicht in den Taxon Editor Gbertragen (,as ...“)

Taxon mit doppelklick im Navigator aufgerufen — die letzten Eintrage sind weg:

04/25/2024 2/9




3 ® Hieronyma clusioides (Tul) Griseb) = Tawon: Hieromyma chrsioides (Tul) Griseb. sec. Greuter & Rankin Rodriguer 2016

@ stilaginella clusioides Tul. Tithe Cache fiecanym e (1 i reuter & Rk o
@ Hieronyma pallida Mall. Arg. Appended Phoase |
Secundum Greuter, W, & Rankin Rodnguez, 7. 2015 The =
0 Antidesma cubanum var, pailidum (Mall. Arg.) M. Gomez [as "eubana var. pallida’) Spermatophyts of Cuba = A Preliminary Checklist _H 4@
Detail |
@ Antidesma rosaarianum M. Ghmez L
: Name in Sounce = n
@ Antidesma rosariana M. Gomez
¥ Links +

Exclude Authorzhip [
Taxen is dovbtful [
Taxcen i published &4
= Mame: Hieromyma chesioides (Tul) Griseb.
Cache Hieror des Grinedy ~
= Scientific Hame: Hieronyma clushsides
Mame Cache Higroayma ¢ =
1l
Rank Species B

Genus Higromyma

Infragenens Epithet
Specific Epithet clusicides
Appended Phrase

= Mustharship: (Tul) Griseb,

Aitherhip Cache

|3 Factunl Data 73 FEETO| M # =16 Author Griseb,

Ex Author

Bamonym Author  Tul 2

LTI
ala e kD

Ex Basspeyymn Authar

¥ Hybeid
| = Homenclatural Source

Reference n

Detaits | ) ]

Cinginad Spelling
¥ Protologue/Ongmal Publication

Dann alles neu eingetragen, alles gut. Scheinbar.

Beim Léschen des Synonyms wurde ich nicht auf das nicht-Namens-léschen hingewiesen.
Der orginal name wurde gel6éscht

Das sieht jetzt so aus:
b— HRE=AN =

5 | BY Astrocasia t.. {35 Breynia dist... [ Chascotheca .. {4 Chascotheca .. [E Hieronyma cl. 52| 2 = 8 ||[# Details 52 ] = E

~ gL}ﬁeranyma clusioides (Tul.) Griseb. - gzl;:nym:.ﬁlmdesma rosaurianum M. Gémez syn. sec. Greuter & Rankin Rodriguez

© stilaginella clusioides Tul.

Title Cache Antidesma rosaurianum M. Gémez syn. sec. Greuter & Rankin
Rodriguez 2016

@ Antidesma rosaurianum M. Gémez Appended Phrase |

©Hicronyma pallida Mil. Arg Secundum Greuter, W. & Rankin Rodriguez, R. 2016: The IE“@”E

Spermatophyta of Cuba - A Preliminary Checklist

© Antidesma cubanum var. pallidum (Miill. Arg.) M. Gémez [as "cubana var. pallida’] Detail |

b Links +
Exclude Authorship  []
Synonym is doubtful []
Synonym is published

]

Name: Antidesma rosaurianum M. Gémez =

Cache Antidesma rosaurianum M. Gémez

~ Scientific Name: Antidesma rosaurianum

Name Cache Antidesma rosaurianum

Rank Species v

Genus Antidesma

Infrageneric Epithet

Specific Epithet rosaurianum

Appended Phrase

4

Authorship: M. Gémez

Authorship Cache M. Gomer

Author M. Gomez

@FactualData Py & = = 0 ﬁMEdIE 23] = 0 =

Ex Author

Basionym Author

CIEICIEIE)

@]6][6]w

Ex Basionym Author

b Hybrid

~ Nomenclatural Source

Reference

Details

Original Spelling

@ | [«

b Protologue/Original Publication

+=)
Referenz ist auch weg.

Related issues:

Related to EDIT - bug #10111: Data loss e.g. when entering type information In Progress
Related to EDIT - bug #10054: Changes on secundum reference are lost after ch... Closed
Related to EDIT - bug #10053: Problems with saving of secundum references Closed
Related to EDIT - bug #10186: Problems with session handling in taxeditor Closed
Related to EDIT - bug #10219: Setting the focus to an already selected entity... New
Related to EDIT - bug #8953: Focus not correctly evaluated for details view w... In Progress
Related to EDIT - bug #10068: Changing focus to accepted taxon does not work Closed

Has duplicate EDIT - bug #8590: Details view does not show data of new synonym Duplicate

Associated revisions

Revision 76d3226¢ - 12/16/2022 04:19 PM - Katja Luther

ref #10138: after parsing send event to update the details view

Revision e751faa2 - 12/16/2022 04:33 PM - Katja Luther

ref #10138: after parsing send event to update the details view - continue

Revision 94fccb8a - 12/20/2022 02:02 PM - Andreas Miiller
ref #10138 disable REFRESH_DETAILS

Revision fef39755 - 12/21/2022 02:27 PM - Katja Luther

ref #10138: handle selection of empty media or factual data view

History

#1 - 09/07/2022 10:12 AM - Katja Luther

- Severity changed from normal to critical

#2 - 09/07/2022 11:05 AM - Katja Luther

- Status changed from New to In Progress

The issue about the nameUsedInSource seems to be a problem of the parser, at the beginning of the parsing all elements are set to null (in
makeEmpty(INonViralName name)), if the string can not be parsed, author and nomenclatural reference and nameUsedInSource are still empty and
will be saved like this.

#3 - 09/07/2022 11:26 PM - Andreas Miiller
- Related to bug #10111: Data loss e.g. when entering type information added

#4 - 09/07/2022 11:26 PM - Andreas Miiller
Maybe related to #10111

#5 - 09/08/2022 11:30 AM - Andreas Miiller
- Status changed from In Progress to Feedback

- Assignee changed from Katja Luther to Andreas Miiller

#6 - 09/08/2022 12:31 PM - Andreas Miiller

- Related to bug #10054: Changes on secundum reference are lost after changing status to basionym added

#7 - 09/08/2022 12:31 PM - Andreas Miiller

- Related to bug #10053: Problems with saving of secundum references added

#8 - 09/13/2022 01:18 PM - Andreas Miiller
- Description updated

#9 - 09/13/2022 01:44 PM - Andreas Miiller

- Status changed from Feedback to Discussed
- Assignee changed from Andreas Mtiller to Katja Luther

- % Done changed from 0 to 10

Katja Luther wrote in #note-2:

The issue about the nameUsedInSource seems to be a problem of the parser, at the beginning of the parsing all elements are set to null (in
makeEmpty(INonViralName name)), if the string can not be parsed, author and nomenclatural reference and nameUsedInSource are still empty
and will be saved like this.

No, this is not the issue here. Fully emptying the name before parsing is wanted behavior.

The problem is the way how the TaxEditor refreshes the DetailsView after changes in the freetext area. The details view is only updated after the
freetext record lost focus. This is partly wanted as we do not want to run parsing after each text change as parsing (and related deduplication) is a
costly serverside function.

However, what is needed here is to not allow editing the details view after changes have been done in the freetext area and the focus is still
on the record that has been changed .

In concrete, what happened here is, that originally the name had a protected namecache and this information still existed in the details view
representation. Therefore changing the nom.source+original name had no effect in the freetext area.

#10 - 09/13/2022 01:50 PM - Andreas Miiller
- Subject changed from Synonyms are deleted to Details view is not updated after freetext change

- Description updated

#11 - 10/11/2022 09:48 AM - Andreas Miiller

- Target version changed from Release 5.33 to Release 5.35

#12 - 11/17/2022 02:35 PM - Katja Luther
- Related to bug #10186: Problems with session handling in taxeditor added

#13 - 12/16/2022 02:37 PM - Andreas Miiller
- Status changed from Discussed to Feedback

- % Done changed from 10 to 60

This is probably fixed but not yet commited.

#14 - 12/16/2022 04:44 PM - Katja Luther
- Status changed from Feedback to Resolved

- % Done changed from 60 to 10

this should be fixed, please review.

#15 - 12/16/2022 05:03 PM - Andreas Miiller
- Assignee changed from Katja Luther to Andreas Mdiller

- % Done changed from 10 to 70

#16 - 12/20/2022 02:08 PM - Andreas Miiller

As far as | can see the event throwing not happens additionally to the event thrown by selection change. We need to check if this results in a
duplicated details view building or if the second build is filtered out somehow. Additionally the REFRESH_DETAILS line seems to be called 2x so
maybe alltogehter DetailsView is build 3x. This needs to be checked before going to production therefore | reverted this line (94fccb8a).

#17 - 12/20/2022 02:10 PM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Muiller to Katja Luther

- % Done changed from 70 to 50

Can you please check this in detail.

#18 - 12/21/2022 10:32 AM - Katja Luther
- Status changed from Feedback to In Progress

Andreas Muller wrote in #note-16:

As far as | can see the event throwing not happens additionally to the event thrown by selection change. We need to check if this results in a
duplicated details view building or if the second build is filtered out somehow. Additionally the REFRESH_DETAILS line seems to be called 2x so
maybe alltogehter DetailsView is build 3x. This needs to be checked before going to production therefore | reverted this line (94fccb8a).

This problem appears if the selected view is for example the empty media view, but not if the selection changes to the details or supplemental data
view.

#19 - 12/22/2022 11:02 AM - Andreas Miuller

Katja Luther wrote in #note-18:
Andreas Muller wrote in #note-16:

As far as | can see the event throwing not happens additionally to the event thrown by selection change. We need to check if this results in
a duplicated details view building or if the second build is filtered out somehow. Additionally the REFRESH_DETAILS line seems to be
called 2x so maybe alltogehter DetailsView is build 3x. This needs to be checked before going to production therefore | reverted this line
(94fccb8a).

This problem appears if the selected view is for example the empty media view, but not if the selection changes to the details or supplemental
data view.

But it also happens when selecting another name in the synonymy. So generally it is maybe not a good idea to refresh the details view after a focus
loss because there is no need to refresh as long as the new focus does not need the exact same input. The refresh should take place when the new
focus has the same input as the old one but data in the old one has changed which is generally not the case - but some cases exist like the one
mentioned in the ticket description.

| think we discussed it the way, that the details view (and maybe others) should be disabled once a change in freetext took place. By clicking on the
details view the new data should be build/inserted.

Additionally we could implement a time triggered parsing after e.g. 3s of no change. The parsing will then also update views.

#20 - 01/05/2023 12:58 AM - Andreas Miuller

- Status changed from In Progress to Feedback

This needs to be reverted or adapted. Currently the detail view very often refreshes. This happens also in many cases when it is not necessary.

E.g.

e changing focus to other synonym in TaxonEditor refreshes the DetailsView 2x(!), first with the old data, then with the new data

¢ changing to focus from synonym to details view or supplementalDataView refreshes the DetailsView if if no data has changed (no parsing) which
is not necessary

¢ changing back from DetailsView or SupplementalDataView to Taxon Editor again refreshes the DetailsView although not necessary

This really slows the TaxEditor in its core functionality.
The reason for the behavior is the above mentioned conceptual mistake.
It does not make sense to refresh DetailsView for any data that /ooses the focus! You need to refresh the View once you know what the new focus is.

So the general rule should be:

¢ Keep everything as in previous versions
e ONLY if the details view gets the focus AND if a name in the TaxEditor had the focus before AND if the name has been parsed due to changes
in freetext THEN refresh the DetailsView.

#21 - 01/05/2023 09:33 AM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

The new solution disables the details view after editing the name in name editor, editing the other names/taxon/synonyms still possible and after
loosing the focus and get it back to the edited name, the details are enabled again because they are refreshed. Please have a look whether this is a
better solution.

#22 - 01/05/2023 10:54 AM - Katja Luther

| just tried out another implementation: now the detailsviewer just remember that there are changes in Name Editor and if it gets the focus the details
view refreshes. If there are no changes, the details view is not updated.
#23 - 01/05/2023 11:10 AM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther

Katja Luther wrote in #note-21:
The new solution disables the details view after editing the name in name editor, editing the other names/taxon/synonyms still possible and after

loosing the focus and get it back to the edited name, the details are enabled again because they are refreshed. Please have a look whether this
is a better solution.

It is much better now. There are just a few improvements that could make work even more comfortable. Currently the disabling is not yet removed in
many cases but it should. E.g. clicking on FactualData View, Media View or SupplementalData View and maybe others should also enable (and
recompute) the DetailsView again. Also clicking on the DetailsView itself | would expect reenables the DetailsView and immediately recomputes it but
I don't know how far this is easy to implement.

#24 - 01/05/2023 11:11 AM - Andreas Miiller
Katja Luther wrote in #note-22:
| just tried out another implementation: now the detailsviewer just remember that there are changes in Name Editor and if it gets the focus the

details view refreshes. If there are no changes, the details view is not updated.

This sounds like the best solution if it works as described.

#25 - 01/05/2023 12:06 PM - Andreas Miiller
- % Done changed from 50 to 70
Andreas Muller wrote in #note-24:
Katja Luther wrote in #note-22:
| just tried out another implementation: now the detailsviewer just remember that there are changes in Name Editor and if it gets the focus
the details view refreshes. If there are no changes, the details view is not updated.

This sounds like the best solution if it works as described.

| tested a bit and it works fully correct. There are only 3 minor issues that might be discussed.

1.If 1 go to the DetailsView (after freetext change) it updates which is correct, if | go back to the freetext it updates again which is not necessary -
hmm, tested and this is also the case without freetext change. So maybe it is another ticket, but if it is easy to fix we may do it now

2. if clicking on the Fact, Media or SupplView the Details View does not refresh though there was change via freetext. One may discuss that this is
wanted behavior as refresh slows down performance but IMO we should refresh as fast as possible once parsing was done.

3.1did like the disabling to indicate that data is not valid anymore so can we keep the disabling and simply do enabling when the view is refreshed.

All these 3 are minor issues and should be implemented in current version only if they are no-brainers and not dangerous to brake anything.
#26 - 01/05/2023 12:20 PM - Katja Luther
Andreas Miiller wrote in #note-25:
Andreas Miiller wrote in #note-24:
Katja Luther wrote in #note-22:
| just tried out another implementation: now the detailsviewer just remember that there are changes in Name Editor and if it gets the
focus the details view refreshes. If there are no changes, the details view is not updated.

This sounds like the best solution if it works as described.

| tested a bit and it works fully correct. There are only 3 minor issues that might be discussed.

1.1f 1 go to the DetailsView (after freetext change) it updates which is correct, if | go back to the freetext it updates again which is not
necessary - hmm, tested and this is also the case without freetext change. So maybe it is another ticket, but if it is easy to fix we may do it
now

This is like it was before, | think there is already a ticket about it. (for example #6554, but this is not for this concrete issue)

1.if clicking on the Fact, Media or SupplView the Details View does not refresh though there was change via freetext. One may discuss that
this is wanted behavior as refresh slows down performance but IMO we should refresh as fast as possible once parsing was done.

In most cases, clicking on the factual data view enables the details of the selected item, otherwise the change would be available if the user
changes the focus again to the details view or the name editor.

1.1 did like the disabling to indicate that data is not valid anymore so can we keep the disabling and simply do enabling when the view is
refreshed.
This can be enabled with one line, | added again.

All these 3 are minor issues and should be implemented in current version only if they are no-brainers and not dangerous to brake anything.

The disabling is added again and the issue about the focus of the factual data, media or supplemental data view can be handled in another ticket, so |
would close this ticket. Do you want to have a final view?

#27 - 01/05/2023 01:06 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

#28 - 01/05/2023 02:17 PM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Muiller to Katja Luther

- % Done changed from 70 to 90

Katja Luther wrote in #note-26:
This is like it was before, | think there is already a ticket about it. (for example #6554, but this is not for this concrete issue)
OK, so if it is not straight forward to implement we leave it for later but we should check if there is really a ticket for it (#6554 is about something else).

It is actually true for the supplemental data view, too, that it often reloads though the data to show is the same. | wonder about this because at other
places we check if the input is the same and do not recompute. Do you know where in the code this happens?

1.if clicking on the Fact, Media or SupplView the Details View does not refresh though there was change via freetext. One may discuss
that this is wanted behavior as refresh slows down performance but IMO we should refresh as fast as possible once parsing was done.

In most cases, clicking on the factual data view enables the details of the selected item, otherwise the change would be available if the user
changes the focus again to the details view or the name editor.

Ok, so we leave it. | was mostly working in synonymies, there Facts and Media are always empty so clicking on them was an easy way to trigger
reload (which actually happens for the SupplementalDataView where it is unwanted - Suppl Data don't change by parsing)

1.1did like the disabling to indicate that data is not valid anymore so can we keep the disabling and simply do enabling when the view is
refreshed.

This can be enabled with one line, | added again.
Works fine
The disabling is added again and the issue about the focus of the factual data, media or supplemental data view can be handled in another

ticket, so | would close this ticket. Do you want to have a final view?

So we can close this ticket but should open new tickets for the open issues if they do not exist yet.

#29 - 01/05/2023 02:50 PM - Katja Luther
- Related to bug #10219: Setting the focus to an already selected entity should not refresh the details view added
#30 - 01/05/2023 02:51 PM - Katja Luther
- Status changed from Feedback to Closed
- % Done changed from 90 to 100

#31 - 01/05/2023 02:59 PM - Andreas Miiller

- Related to bug #8953: Focus not correctly evaluated for details view when switching between names added

#32 - 01/05/2023 03:01 PM - Andreas Miiller
- Related to bug #10068: Changing focus to accepted taxon does not work added

#33 - 01/05/2023 05:05 PM - Andreas Miiller

- Has duplicate bug #8590: Details view does not show data of new synonym added
